Zum Hauptinhalt springen

dhtmlxGantt with Vue.js

Hinweis

This tutorial shows how to use the JS DHTMLX Gantt package directly in a Vue app without the official wrapper.

If you want Vue props/events, wrapper-managed sync, and wrapper composables, use Vue Gantt instead.

This page is for low-level integration. You initialize and manage the Gantt instance yourself.

Prerequisites

  • Node.js installed
  • Basic Vue 3 knowledge (components, refs, lifecycle hooks)
  • A Vue 3 project (this tutorial shows how to create one with Vite)

1. Create A Vue Project

Create a Vue 3 app with Vite:

npm create vue@latest gantt-vue-app
cd gantt-vue-app

Install dependencies and start the dev server once to confirm the project works:

  • npm:
npm install
npm run dev
  • yarn:
yarn install
yarn dev

The app should be available at http://localhost:5173.

Gantt Vue app running

Stop the dev server (Ctrl+C) before the next step.

2. Install The JS Gantt Package

Professional builds of the JS Gantt library are available via private npm. Follow the installation guide to get access.

Evaluation build (public tutorial package):

  • npm:
npm install @dhx/trial-gantt
  • yarn:
yarn add @dhx/trial-gantt

Professional build (private npm):

  • npm:
npm install @dhx/gantt
  • yarn:
yarn add @dhx/gantt

You can also install Gantt from a local folder because the package is structured as an npm module.

3. Create A Gantt Component

Create src/components/GanttView.vue and initialize Gantt in Vue lifecycle hooks.

If you installed the evaluation build, use these imports:

src/components/GanttView.vue
<script setup lang="ts">
import { onBeforeUnmount, onMounted, ref } from "vue";
import { Gantt, type GanttStatic } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

const container = ref<HTMLElement | null>(null);
let gantt: GanttStatic | null = null;

onMounted(() => {
if (!container.value) return;

gantt = Gantt.getGanttInstance();
gantt.init(container.value);
});

onBeforeUnmount(() => {
gantt?.destructor();
gantt = null;
});
</script>

<template>
<div ref="container" className="gantt-host"></div>
</template>

<style>
.gantt-host {
width: 100%;
height: 600px;
}
</style>

If you installed the professional build, replace the package imports:

import { Gantt, type GanttStatic } from "@dhx/gantt";
import "@dhx/gantt/codebase/dhtmlxgantt.css";

If you installed Gantt from a local folder package, imports usually look like this:

import { Gantt, type GanttStatic } from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";

4. Render The Gantt Component In The App

Replace src/App.vue:

src/App.vue
<script setup lang="ts">
import GanttView from "./components/GanttView.vue";
</script>

<template>
<GanttView />
</template>

To let the chart use the page height, update your global styles (for example src/assets/main.css):

src/assets/main.css
html,
body,
#app {
width: 100%;
height: 100vh;
margin: 0;
padding: 0;
}

Start the app again. You should see an empty Gantt chart.

5. Provide Data

Create src/demo-data.ts:

src/demo-data.ts
export function getData() {
return {
data: [
{
id: 10,
text: "Project #1",
start_date: "2026-02-02 00:00",
duration: 6,
progress: 0.4,
open: true
},
{
id: 1,
text: "Task #1",
start_date: "2026-02-02 00:00",
duration: 2,
progress: 0.6,
parent: 10
},
{
id: 2,
text: "Task #2",
start_date: "2026-02-04 00:00",
duration: 3,
progress: 0.2,
parent: 10
}
],
links: [{ id: 1, source: 1, target: 2, type: "0" }]
};
}

Update src/components/GanttView.vue and parse the data:

src/components/GanttView.vue
<script setup lang="ts">
import { onBeforeUnmount, onMounted, ref } from "vue";
import { Gantt, type GanttStatic } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
import { getData } from "../demo-data";

const container = ref<HTMLElement | null>(null);
let gantt: GanttStatic | null = null;

onMounted(() => {
if (!container.value) return;

gantt = Gantt.getGanttInstance();
gantt.config.date_format = "%Y-%m-%d %H:%i";
gantt.init(container.value);
gantt.parse(getData());
});

onBeforeUnmount(() => {
gantt?.destructor();
gantt = null;
});
</script>

<template>
<div ref="container" className="gantt-host"></div>
</template>

<style>
.gantt-host {
width: 100%;
height: 600px;
}
</style>

Reload the page. You should see a Gantt chart with tasks and a dependency link.

6. Capture And Save Changes

Use a dataProcessor to handle chart changes and send them to your backend.

Add a handler after gantt.init(...):

gantt.createDataProcessor((entity, action, data, id) => {
console.log("[dp]", entity, action, data, id);
});

DHTMLX Gantt accepts Promise responses from dataProcessor handlers. If your backend changes IDs on create, return an object like { id: newId } or { tid: newId } so Gantt can remap the record.

For full backend patterns, see server-side integration.

Result

You now have a Vue app with direct JS Gantt integration:

  • Vue owns the component lifecycle
  • your code initializes and destroys the Gantt instance
  • data is loaded with gantt.parse(...)
  • edits can be handled with gantt.createDataProcessor(...)

Security Note

Gantt does not protect your backend from SQL injection, XSS, or CSRF. Backend validation, authorization, and output sanitization remain your responsibility.

Read Application Security for the main risk areas and mitigation guidance.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

dhtmlxGantt mit React
Dieses Tutorial behandelt die Verwendung des JS DHTMLX Gantt in React-Apps. Wenn Sie die offizielle React Gantt-Komponente verwenden möchten, lesen Sie bitte den React Gantt-Artikel.
Sie sollten mit den grundlegenden Konzepten und Mustern von React vertraut sein, um diese Dokumentation zu verwenden. Falls Sie nicht vertraut sind, lesen Sie bitte die React-Dokumentation für ein Schnellstart-Tutorial.
DHTMLX Gantt ist mit React kompatibel. Sie können das entsprechende Beispiel auf GitHub einsehen: DHTMLX Gantt mit React Demo.
Erstellung eines Projekts
Bevor Sie ein neues Projekt erstellen, installieren Sie Node.js.
Sie können ein grundlegendes React-Projekt mit dem folgenden Befehl erstellen:
npx create-vite my-react-gantt-app --template react
Installation der Abhängigkeiten
Als Nächstes wechseln Sie in das App-Verzeichnis. Wir nennen unser Projekt my-react-gantt-app und führen Folgendes aus:
cd my-react-gantt-app
Anschließend sollten Sie Abhängigkeiten installieren und den Entwickl-Server starten. Dafür verwenden Sie einen Paketmanager:
- falls Sie yarn verwenden, führen Sie die folgenden Befehle aus:
yarn install
yarn dev
- falls Sie npm verwenden, führen Sie die folgenden Befehle aus:
npm install
npm run dev
Sie sollten Ihr React-Projekt nun unter http://localhost:5173 laufen sehen.

Erstellung des Gantt
Nun sollten wir den DHTMLX Gantt-Code erhalten. Zunächst müssen wir die Anwendung durch Drücken von Ctrl+C in der Befehlszeile stoppen. Danach können wir mit der Installation des Gantt-Pakets fortfahren.
Schritt 1. Paketinstallation
Die PRO-Versionen der Bibliothek sind für die npm/yarn-Installation aus unserem privaten Repository verfügbar. Bitte folgen Sie dieser Anleitung, um Zugriff darauf zu erhalten.
Sobald Sie die Evaluierungsversion des Gantt erhalten haben, können Sie sie mit den folgenden Befehlen installieren:
- für npm:
npm install @dhx/trial-gantt
- für yarn:
yarn add @dhx/trial-gantt
Alternativ, da das Zip-Paket der Bibliothek als npm-Modul strukturiert ist, können Sie es von einem lokalen Ordner installieren.
Schritt 2. Komponentenerstellung
Nun sollten wir eine React-Komponente erstellen, um ein Gantt in die Anwendung einzufügen. Erstellen Sie die Gantt.jsx-Datei im src/ Verzeichnis.
Importieren der Quelldateien
Öffnen Sie die neu erstellte Gantt.jsx-Datei und importieren Sie die Gantt-Quelldateien. Beachten Sie Folgendes:
- Wenn Sie das Gantt-Paket aus einem lokalen Ordner installiert haben, sehen Ihre Importpfade wie folgt aus:
import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
- Wenn Sie die Trial-Version installiert haben, sollten die Importpfade wie folgt aussehen:
import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
In diesem Tutorial verwenden wir die trial Version von Gantt.
Festlegen des Containers und Hinzufügen von Gantt
Um Gantt auf der Seite anzuzeigen, müssen wir den Container festlegen, in dem die Komponente gerendert wird. Die Gantt.jsx-Datei sollte den folgenden Code enthalten:
import { useEffect, useRef } from "react"; /*!*/
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
export default function GanttView() { /*!*/
let container = useRef(); /*!*/
useEffect(() => { /*!*/
let gantt = Gantt.getGanttInstance(); /*!*/
gantt.init(container.current); /*!*/
return () => { /*!*/
gantt.destructor(); /*!*/
container.current.innerHTML = ""; /*!*/
}; /*!*/
}, []); /*!*/
return <div ref="{container}" style={{}} {width: "100%", height: "100%"} }></div>; /*!*/
} /*!*/
Schritt 3. Gantt in die App einfügen
Nun ist es Zeit, die Komponente in unsere App einzufügen. Öffnen Sie src/app.jsx und verwenden Sie die Gantt-Komponente anstelle des Standardinhalts, indem Sie den folgenden Code einfügen:
import Gantt from "./Gantt";
function App() {
return <Gantt/>;
}
export default App;
Damit der Gantt-Container den gesamten Bereich des Bodys ausfüllt, entfernen Sie die Standardstilregeln aus der index.css-Datei im src/ Ordner und fügen Sie die folgende hinzu:
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}
Danach sollten wir beim Start der App ein leeres Gantt auf der Seite sehen:
Schritt 4. Bereitstellung von Daten
Um Daten in das Gantt einzufügen, müssen wir einen Datensatz bereitstellen. Erstellen Sie die Datei data.js im src/-Verzeichnis und fügen Sie einige Daten hinzu:
export function getData() {
const tasks = {
data: [
{
id: "10",
text: "Project #1",
start_date: "01-04-2025",
duration: 3,
order: 10,
progress: 0.4,
open: true,
},
{
id: "1",
text: "Task #1",
start_date: "01-04-2025",
duration: 1,
order: 10,
progress: 0.6,
parent: "10",
},
{
id: "2",
text: "Task #2",
start_date: "02-04-2025",
duration: 2,
order: 20,
progress: 0.6,
parent: "10",
},
],
links: [{ id: 1, source: 1, target: 2, type: "0" }],
};
return tasks;
}
Wir sollten Props übergeben (unsere Daten) zu einer Gantt-Komponente in App.jsx:
import Gantt from "./Gantt";
import { getData } from "./data.js";
function App() {
return <Gantt tasks="{getData()}" />;
}
export default App;
Und verwenden Sie die Props in der gantt.parse()-Methode der Gantt-Komponente:
import { useEffect, useRef } from "react";
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
export default function GanttView(props) {
let container = useRef();
useEffect(() => {
let gantt = Gantt.getGanttInstance();
gantt.init(container.current);
gantt.parse(props.tasks); /*!*/
return () => {
gantt.destructor();
container.current.innerHTML = "";
};
}, []);
return <div ref="{container}" style={{}} {width: "100%", height: "100%"} }></div>;
}
Nun, wenn Sie die App-Seite erneut öffnen, sollten Sie ein Gantt mit Aufgaben sehen:

Schritt 5. Speichern von Daten
Um Änderungen im Gantt zu erfassen, können Sie einen dataProcessor-Handler verwenden, der eine Kommunikation mit dem serverseitigen Backend ermöglicht. Der Handler kann entweder als Funktion oder als Router-Objekt deklariert werden. dhtmlxGantt akzeptiert eine Promise-Antwort vom Handler, sodass Ihr Gantt die Ausführung einer Aktion korrekt verarbeitet.
Sie können einen DataProcessor über die API-Methode createDataProcessor() erstellen und Änderungen so erfassen:
gantt.createDataProcessor(function(entity, action, data, id) {
gantt.message(`${entity} ${action}`);
});
Falls Ihr Service die Aufgaben-ID nach dem Anlegen eines neuen Datensatzes ändert (was üblicherweise der Fall ist), stellen Sie sicher, dass Ihre Promise ein Objekt mit (id: databaseId) oder (tid: databaseId) als Ergebnis zurückgibt, damit Gantt die neue Datenbank-ID dem Datensatz zuweisen kann. Erfahren Sie weitere Informationen zur Server-Seite.
Nun ist React Gantt bereit. Sie können sich die vollständige Demo auf GitHub ansehen: DHTMLX Gantt mit React Demo.
XSS-, CSRF- und SQL-Injektionsangriffe
Achten Sie darauf, dass Gantt keine Mittel zur Verhinderung von Bedrohungen in einer Anwendung bietet, wie SQL-Injektionen oder XSS- und CSRF-Angriffe. Es ist wichtig, dass die Verantwortung für die Sicherheit einer Anwendung von den Entwicklern getragen wird, die das Backend implementieren.
Lesen Sie den Artikel Anwendungssicherheit, um die verwundbarsten Punkte der Komponente zu erfahren und die Maßnahmen zu lernen, die Sie ergreifen können, um die Sicherheit Ihrer Anwendung zu verbessern.

Zum Hauptinhalt springen

dhtmlxGantt with Angular

Hinweis

This tutorial shows how to use the JS DHTMLX Gantt directly in an Angular app without the official wrapper.

If you want Angular inputs/outputs, wrapper-managed sync, and Angular template component support, use Angular Gantt instead.

You should be familiar with basic Angular concepts (components, lifecycle hooks, services). If not, start with the Angular documentation.

DHTMLX Gantt is compatible with Angular. You can check the related demo repository on GitHub: DHTMLX Gantt with Angular Demo.

Creating A Project

Before you start, install Node.js and Angular CLI.

Create a new Angular app:

ng new my-angular-gantt-app --standalone --routing=false --style=css
cd my-angular-gantt-app

Start the app once to verify the project is working:

  • npm: npm start
  • yarn: yarn start
  • or CLI: ng serve

The app should be available at http://localhost:4200.

Creating Gantt

Stop the dev server (Ctrl+C) before installing the Gantt package.

Step 1. Package Installation

Professional builds of the JS Gantt library are available via private npm. Follow the installation guide to get access.

Evaluation build (public package for tutorials):

  • npm:
npm install @dhx/trial-gantt
  • yarn:
yarn add @dhx/trial-gantt

Professional build (private npm):

  • npm:
npm install @dhx/gantt
  • yarn:
yarn add @dhx/gantt

You can also install Gantt from a local folder because the package is structured as an npm module.

Step 2. Create A Gantt Component

Create a new component for direct JS Gantt integration:

ng generate component gantt --skip-tests

Import Gantt Source Files

Open src/app/gantt/gantt.component.ts and import the Gantt package.

If you installed the evaluation build:

src/app/gantt/gantt.component.ts
import { Gantt, type GanttStatic } from '@dhx/trial-gantt';

If you installed the professional build:

src/app/gantt/gantt.component.ts
import { Gantt, type GanttStatic } from '@dhx/gantt';

Add Gantt styles in src/app/gantt/gantt.component.css.

Evaluation build:

src/app/gantt/gantt.component.css
@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

Professional build:

src/app/gantt/gantt.component.css
@import "@dhx/gantt/dist/dhtmlxgantt.css";

Initialize Gantt In Angular Lifecycle Hooks

Replace src/app/gantt/gantt.component.ts with a minimal direct integration:

src/app/gantt/gantt.component.ts
import { AfterViewInit, Component, ElementRef, OnDestroy, ViewChild, ViewEncapsulation } from '@angular/core';
import { Gantt, type GanttStatic } from '@dhx/trial-gantt';

@Component({
selector: 'app-gantt',
standalone: true,
template: `<div #ganttHost className="gantt-chart"></div>`,
styleUrl: './gantt.component.css',
encapsulation: ViewEncapsulation.None,
})
export class GanttComponent implements AfterViewInit, OnDestroy {
@ViewChild('ganttHost', { static: true }) ganttHost!: ElementRef<HTMLElement>;

private gantt: GanttStatic | null = null;

ngAfterViewInit(): void {
const gantt = Gantt.getGanttInstance();
gantt.init(this.ganttHost.nativeElement);
this.gantt = gantt;
}

ngOnDestroy(): void {
this.gantt?.destructor();
this.gantt = null;
}
}

Add basic container sizing to src/app/gantt/gantt.component.css:

src/app/gantt/gantt.component.css
@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

.gantt-chart {
width: 100%;
height: 600px;
}

Step 3. Add Gantt To The App

Replace src/app/app.component.ts so the app renders your Gantt component:

src/app/app.component.ts
import { Component } from '@angular/core';
import { GanttComponent } from './gantt/gantt.component';

@Component({
selector: 'app-root',
standalone: true,
imports: [GanttComponent],
template: `<app-gantt></app-gantt>`,
})
export class AppComponent {}

After starting the app, you should see an empty Gantt chart.

Step 4. Provide Data

Create src/app/demo-data.ts with a small dataset:

src/app/demo-data.ts
export function getData() {
return {
data: [
{
id: 10,
text: 'Project #1',
start_date: '2026-02-02 00:00',
duration: 6,
progress: 0.4,
open: true,
},
{
id: 1,
text: 'Task #1',
start_date: '2026-02-02 00:00',
duration: 2,
progress: 0.6,
parent: 10,
},
{
id: 2,
text: 'Task #2',
start_date: '2026-02-04 00:00',
duration: 3,
progress: 0.2,
parent: 10,
},
],
links: [{ id: 1, source: 1, target: 2, type: '0' }],
};
}

Now import and parse the data in GanttComponent:

src/app/gantt/gantt.component.ts
import { getData } from '../demo-data';

// ...inside ngAfterViewInit()
const gantt = Gantt.getGanttInstance();
gantt.config.date_format = '%Y-%m-%d %H:%i';
gantt.init(this.ganttHost.nativeElement);
gantt.parse(getData());
this.gantt = gantt;

If you reload the app, you should see a Gantt chart with tasks and a link.

Step 5. Save Data

To capture changes made in the chart, use a dataProcessor. It can send changes to your backend or just log them while you build the integration.

src/app/gantt/gantt.component.ts
// ...inside ngAfterViewInit(), after gantt.init(...)
gantt.createDataProcessor((entity, action, data, id) => {
console.log('[dp]', entity, action, data, id);
});

DHTMLX Gantt accepts Promise responses from dataProcessor handlers. If your backend changes IDs on create, return an object like { id: newId } or { tid: newId } so Gantt can remap the record.

See server-side integration for full backend patterns.

XSS, CSRF And SQL Injection Attacks

Gantt does not protect your application from backend security issues (SQL injection, XSS, CSRF). Backend validation, authorization, and output sanitization remain your responsibility.

Read Application Security for the main risk areas and mitigation guidance.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.